'by David Ratcliff  'ratronic' 5/15/10              demo of stingray and arm operating with sony tv remote
CON

  _clkmode = xtal1 + pll16x                    'set propeller to run @ 80mhz
  _clkfreq = 80_000_000

  base_pin = 24                                'set base pin for pwm object
  freq     = 23000                             'set pwm frequency
  spd      = 80                                'set robot motors speed
         
VAR

  byte flag, ircode                            'flag = move robot or arm
                                               'ircode = detected ir button pressed, if ircode = 255 no button is being pressed    
OBJ

   dy : "dynacomv1.2"                          'dynamixel servo driver                                                                                                 
   ir : "ir_remote"                            'sony tv ir remote object                 
  Pwm : "PWMx8"                                'pulse width modulation object
    
PUB Main | i

' initialize
  
  ir.start(16, @ircode)                        'start ir object on propeller i/o# 16  (ircode = button pressed - 255 means no button pressed)
  pwm.start(base_pin, %00001111, freq)         'start pwm object
  dy.start(0,1000_000)                         'start dynamixel servo driver on propeller i/o# 0 @ 1m baud connection
  repeat i from 1 to 3                         'set servo id's# 1-3 with 100 speed
    dy.setsrvspd(1, 100)
  dy.setarmpos(0)                              'set initial arm position up, can be set to 0-330
  dy.grpposd(300)                              'set initial gripper position to open
  waitcnt(clkfreq*3 +cnt)                      'wait for servos to finish moving
  flag := 0                                    'set flag to move robot initialy
  
' main loop

  repeat                                       
    if ircode == 0                             'if 1 pressed set flag to move robot       
      flag := 0
    if ircode == 1                             'if 2 pressed set flag to move arm
      flag := 1
    if ircode == 116 or ircode == 117 or ircode == 51 or ircode == 52  'if menu up, down, left, or right pressed move arm or robot depending on flag  
      if flag == 0                             'if flag = 0, move robot 
        move_robot                    
      if flag == 1                             'if flag = 1, move arm
        move_arm   
            
PUB Move_Robot                                 'start and stop robot motors depending on remote button being pressed
  
  repeat
    if ircode == 51                            'left button, turn left
      setmotor(0, spd)       
      setmotor(1, -spd)      
    if ircode == 52                            'right button, turn right
      setmotor(0, -spd)      
      setmotor(1, spd)       
    if ircode == 117                           'up button, go forward
      setmotor(0,-spd)       
      setmotor(1,-spd)                         
    if ircode == 116                           'down button, go reverse   
      setmotor(0, spd)       
      setmotor(1, spd)       
    if ircode == 255                           '255 means no button being pressed, stop motors and return
      setmotor(0, 0)
      setmotor(1, 0)
      return
      
PUB Move_Arm                                   'move arm / gripper  depending on which button pressed

  repeat
    if ircode == 51                            
      dy.clsgrpd                               'close the gripper 
    if ircode == 52
      dy.grpposd(300)                          'open gripper (dual servo gripper)
    if ircode == 116       
      dy.setarmpos(100)                        'move arm to position 100 (most of the way up) 
    if ircode == 117           
      dy.setarmpos(330)                        'move arm to down position
    if ircode == 255                           '255 means no button being pressed - return       
      return                   

Pub SetMotor(Motor, Speed)                     'set robot motors to move, motor = 0 or 1, speed = -255 to 255 (reverse to forward)

  Speed := -255 #> Speed <# 255

  if Motor
  
    ifnot Speed & $80_00_00_00  
      Pwm.Duty(BASE_PIN + 2, Speed & $FF)
      Pwm.Duty(BASE_PIN + 3, 0)
    else
      Pwm.Duty(BASE_PIN + 2, 0)
      Pwm.Duty(BASE_PIN + 3, (0 - Speed) & $FF)
  else
    ifnot Speed & $80_00_00_00  
      Pwm.Duty(BASE_PIN + 1, Speed & $FF)
      Pwm.Duty(BASE_PIN, 0)
    else
      Pwm.Duty(BASE_PIN + 1, 0)
      Pwm.Duty(BASE_PIN, (0 - Speed) & $FF)